require("binstd")
require("socket")

local dbg = false

function dbgmsg(...)
	if dbg then
		usermsg(unpack(arg))
	end
end

function usermsg(...)
	io.stderr:write(unpack(arg))
end

function http_get_header(urn, start, size, file_size, file_name, host)
	return [[GET /uri-res/N2R?]]..urn..
		((file_size and '&xl='..file_size) or '')..
		((file_name and '&dn='..file_name) or '')..
		' HTTP/1.1'..'\n'..
		((host and 'Host: '..host..'"\n') or '') ..
		[[User-Agent: Player/0.1]]..'\n'..
		[[X-Content-URN: ]]..urn..'\n'..
		[[X-Features: g2/0.1]]..'\n'..
		[[Connection: Keep-Alive]]..'\n'..
		[[Range: bytes=]]..start..'-'..(start+size-1)
end



function main()
	local st = -1 
	
	--[[
		-2 stdout closed
		-1 http connection closed
		 0, 4 send request
		 0 detect HTTP
		 1, 2 read headers
		 3 data
	]]
	
	
	local ignore_data
	local block = 1000000
	local point = 0
	local file_size = 0
	local urn, line, ver, code, msg, len
	local address, port, shareaza = arg[1], tonumber(arg[2])
	
	while not urn do
		if not arg[3] then
			usermsg("\ninput urn or magnet, or press Enter to exit: \n")
		end
		magnet = arg[3] or io.stdin:read("*l")
		if #magnet <= 1 then os.exit(0) end
		dbgmsg("\nmagnet: ", magnet)
		urn = string.match(magnet, "(urn:[0-z:%./]+)")
		if not urn then
			usermsg("\nurn not found; pattern: (urn:[0-z:%./]+)")
			arg[3] = nil
		else 
			usermsg("\nurn found: ", urn)
		end
	end
	

	while ( st > -2 ) and ( file_size > point ) do
		
		if st == -1 then
			if shareaza then 
				shareaza:close() 
				socket.sleep(5)
			end
			dbgmsg( "\nconnecting: ", address, ":", port )
			shareaza = socket.connect(address, port)
			if shareaza then st = 0 end
		end
		
		if st == 0 or st == 4 then
		    if dbg then io.stderr:write( "\n\n" .. string.rep( "-", 80 ) .. "\n" ) end
			ver, code, msg, len = nil, nil, nil, nil
			request = http_get_header(urn, point, block).."\n\n"
			dbgmsg("\n"..request)
			shareaza:send(request)
			st = 0
		end

		if st >= 0 then
			line, err = shareaza:receive( "*l" )
			if err then 
				dbgmsg( "\n"..st..": ", err )
				st = -1
			else
				if #line > 0 then dbgmsg("\n"..st..": ", line) end
			end
		end
		
		if st == 3 and #line == 0 then
			dbgmsg("\n"..st..": ignore_data = ", (ignore_data and "on") or "off")
			local send_len = 0
			local chunck = 1000
			st = 4
			while send_len < len and not err do
				if send_len + chunck > len then  chunck = len - send_len end
				local data, err, part = shareaza:receive(chunck)
				if data and not ignore_data then 
					if not io.stdout:write(data) then
						st = -2
						break
					end
					send_len = send_len + #data
				elseif err then 
					dbgmsg("\n"..st..": ", err)
					st = -1
					if part and (not ignore_data) then
						if io.stdout:write(part) then
							send_len = send_len + #part
						else
							st = -2
						end
					end
					break
				end
				socket.sleep(0.001)
			end
			
			if ignore_data then
				socket.sleep(1)
				ignore_data = false
			else
				point = point + send_len
				dbgmsg("\n"..st..": point = ", point)
			end
		end
		
		if (st == 1) or (st == 2) then
			local rlen = string.match(line, "Content%-Length: ([0-9]+)")
			if rlen then len = tonumber(rlen); st = st + 1 end
			
			local rstart, rend, fsize = string.match(line, "Content%-Range: bytes=([0-9]+)%-([0-9]+)/([0-9]+)")
			if tonumber(rstart) == point then st = st + 1 elseif rstart then ignore_data = true end
			if code == "206" and not ignore_data then
				file_size = fsize
			end
		end
		
		if st == 0 then
			ver, code, msg = string.match(line, "HTTP/([0-9].[0-9x]) ([0-9]+) (.*)")
			if code == "206" then 
				st = 1 
			elseif code then 
				st = 2
				ignore_data = code~="200"
			end
		end
	end
end

main()
